.386
.model small, stdcall
option casemap: none
;========================================================================================================================
include		<windows.inc>
include		<kernel32.inc>
include		<user32.inc>

includelib	<kernel32.lib>
includelib	<user32.lib>
;========================================================================================================================
.data
	g_szFileName			db		"Test.txt", 0
	g_buffer				db		"This is a test", 0	
	g_szMsgCaption			db		"Win32 Console", 0
	g_szMsgSuccess			db		"Success", 0
	g_szMsgError			db		"Error", 0
;========================================================================================================================
.code

main proc
	LOCAL	hFile:		HANDLE
	LOCAL	dwSize:		DWORD
	LOCAL	dwWritten:	DWORD
	
	; Try to create new file (overwrite if exist)
	invoke	CreateFile, addr g_szFileName, GENERIC_WRITE, FILE_SHARE_READ, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL
	.if eax == INVALID_HANDLE_VALUE
		;CreateFile error
		invoke	MessageBox, NULL, addr g_szMsgError, addr g_szMsgCaption, MB_OK + MB_ICONERROR
		ret
	.endif
	mov		hFile, eax					; Save file handle
	
	invoke	lstrlen, addr g_buffer
	mov		dwSize, eax					; Get buffer size
	
	; Try to write buffer to file
	invoke	WriteFile, hFile, addr g_buffer, dwSize, addr dwWritten, NULL
	mov		ecx, dwWritten
	.if ecx < dwSize
		invoke	MessageBox, NULL, addr g_szMsgError, addr g_szMsgCaption, MB_OK + MB_ICONERROR
	.else
		invoke	MessageBox, NULL, addr g_szMsgSuccess, addr g_szMsgCaption, MB_OK + MB_ICONINFORMATION
	.endif
	invoke	CloseHandle, hFile			; Close file
	ret
main endp
;========================================================================================================================
end		main